gcc_update 15 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417
  1. #! /bin/sh
  2. #
  3. # Update a local Subversion, Git or Mercurial tree from the GCC
  4. # repository, with an emphasis on treating generated files correctly, so
  5. # that autoconf, gperf et al are not required for the ``end'' user.
  6. #
  7. # (C) 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2009, 2010,
  8. # 2011 Free Software Foundation
  9. # Originally by Gerald Pfeifer <pfeifer@dbai.tuwien.ac.at>, August 1998.
  10. #
  11. # This script is Free Software, and it can be copied, distributed and
  12. # modified as defined in the GNU General Public License. A copy of
  13. # its license can be downloaded from http://www.gnu.org/copyleft/gpl.html
  14. #
  15. #
  16. # By default all command-line options are passed to `svn update` or `hg/git
  17. # pull` in addition to $UPDATE_OPTIONS (defined below). If the first parameter
  18. # reads --nostdflags, $UPDATE_OPTIONS as well as this parameter itself
  19. # are omitted.
  20. #
  21. # If the first parameter reads --patch, the second parameter is considered
  22. # a patch file.
  23. #
  24. # If the first parameter is --touch, no svn operation will be performed,
  25. # only generated files that appear to be out of date in the local tree
  26. # will be touched.
  27. #
  28. # If the first parameter is --list, a list of the generated files and
  29. # their dependencies will be printed; --help prints this message.
  30. #
  31. # If the first parameter is --silent, this script prints nothing other
  32. # than error messages; the second parameter is then interpreted as above.
  33. #
  34. # Examples:
  35. #
  36. # contrib/gcc_update -r 8712
  37. # contrib/gcc_update --patch some-patch
  38. # contrib/gcc_update --touch
  39. # contrib/gcc_update --list
  40. # Default options used when updating (none).
  41. UPDATE_OPTIONS=""
  42. # Set the locale to C to make this script work for users with foreign
  43. # locale like e.g. French UTF-8.
  44. LANG=C
  45. LC_ALL=C
  46. export LANG LC_ALL
  47. ######## Anything below shouldn't be changed by regular users.
  48. # Arrange for the value of $0 to be available for functions
  49. self=$0
  50. # This function prints its arguments to standard output unless
  51. # "silent" is set.
  52. unset silent
  53. chat () {
  54. if [ -z "$silent" ]; then
  55. echo "$@"
  56. fi
  57. }
  58. # This function prints a list of all generated files, along with their
  59. # dependencies. Note that only one target is supported per line: the
  60. # colon is stripped from the output.
  61. files_and_dependencies () {
  62. sed -e 's/ *#.*//' -e '/^$/d' -e 's/://' <<\EOF
  63. # fixincludes
  64. fixincludes/configure: fixincludes/configure.ac fixincludes/aclocal.m4
  65. fixincludes/config.h.in: fixincludes/configure.ac fixincludes/aclocal.m4
  66. # intl library
  67. intl/plural.c: intl/plural.y
  68. intl/configure: intl/configure.ac intl/aclocal.m4
  69. intl/config.h.in: intl/configure.ac intl/aclocal.m4
  70. # Now, proceed to gcc automatically generated files
  71. gcc/configure: gcc/configure.ac
  72. gcc/cstamp-h.in: gcc/configure.ac
  73. gcc/config.in: gcc/cstamp-h.in
  74. gcc/fixinc/fixincl.x: gcc/fixinc/fixincl.tpl gcc/fixinc/inclhack.def
  75. gcc/config/aarch64/aarch64-tune.md: gcc/config/aarch64/aarch64-cores.def gcc/config/aarch64/gentune.sh
  76. gcc/config/arm/arm-tune.md: gcc/config/arm/arm-cores.def gcc/config/arm/gentune.sh
  77. gcc/config/arm/arm-tables.opt: gcc/config/arm/arm-arches.def gcc/config/arm/arm-cores.def gcc/config/arm/arm-fpus.def gcc/config/arm/genopt.sh
  78. gcc/config/avr/avr-tables.opt: gcc/config/avr/avr-mcus.def gcc/config/avr/genopt.sh
  79. gcc/config/avr/t-multilib: gcc/config/avr/avr-mcus.def gcc/config/avr/genmultilib.awk
  80. gcc/config/c6x/c6x-tables.opt: gcc/config/c6x/c6x-isas.def gcc/config/c6x/genopt.sh
  81. gcc/config/c6x/c6x-sched.md: gcc/config/c6x/c6x-sched.md.in gcc/config/c6x/gensched.sh
  82. gcc/config/c6x/c6x-mult.md: gcc/config/c6x/c6x-mult.md.in gcc/config/c6x/genmult.sh
  83. gcc/config/m68k/m68k-tables.opt: gcc/config/m68k/m68k-devices.def gcc/config/m68k/m68k-isas.def gcc/config/m68k/m68k-microarchs.def gcc/config/m68k/genopt.sh
  84. gcc/config/mips/mips-tables.opt: gcc/config/mips/mips-cpus.def gcc/config/mips/genopt.sh
  85. gcc/config/rs6000/rs6000-tables.opt: gcc/config/rs6000/rs6000-cpus.def gcc/config/rs6000/genopt.sh
  86. gcc/config/tilegx/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
  87. gcc/config/tilepro/mul-tables.c: gcc/config/tilepro/gen-mul-tables.cc
  88. # And then, language-specific files
  89. gcc/cp/cfns.h: gcc/cp/cfns.gperf
  90. gcc/java/keyword.h: gcc/java/keyword.gperf
  91. # testsuite
  92. # Without this, _Pragma3.c can have a false negative.
  93. gcc/testsuite/gcc.dg/cpp/_Pragma3.c: gcc/testsuite/gcc.dg/cpp/mi1c.h
  94. # Similarly, without this, you will see:
  95. # direct2s.c:35: warning: current file is older than direct2.c
  96. gcc/testsuite/gcc.dg/cpp/direct2s.c: gcc/testsuite/gcc.dg/cpp/direct2.c
  97. # lto-plugin
  98. lto-plugin/configure: lto-plugin/configure.ac lto-plugin/aclocal.m4
  99. lto-plugin/Makefile.in: lto-plugin/Makefile.am lto-plugin/aclocal.m4
  100. # And libraries, at last
  101. libbanshee/configure: libbanshee/configure.ac
  102. libmudflap/configure: libmudflap/configure.ac
  103. libobjc/configure: libobjc/configure.ac
  104. zlib/aclocal.m4: zlib/configure.ac zlib/acinclude.m4
  105. zlib/Makefile.in: zlib/Makefile.am zlib/configure.ac zlib/aclocal.m4
  106. zlib/configure: zlib/configure.ac zlib/aclocal.m4
  107. fastjar/aclocal.m4: fastjar/configure.ac
  108. fastjar/Makefile.in: fastjar/Makefile.am fastjar/configure.ac fastjar/aclocal.m4
  109. fastjar/configure: fastjar/configure.ac fastjar/aclocal.m4
  110. boehm-gc/aclocal.m4: boehm-gc/configure.ac
  111. boehm-gc/Makefile.in: boehm-gc/Makefile.am boehm-gc/configure.ac boehm-gc/aclocal.m4
  112. boehm-gc/configure: boehm-gc/configure.ac boehm-gc/aclocal.m4
  113. libada/configure: libada/configure.ac
  114. libffi/aclocal.m4: libffi/configure.ac libffi/acinclude.m4
  115. libffi/Makefile.in: libffi/Makefile.am libffi/configure.ac libffi/aclocal.m4
  116. libffi/configure: libffi/configure.ac libffi/aclocal.m4
  117. libffi/fficonfig.h.in: libffi/configure.ac libffi/aclocal.m4
  118. libgfortran/aclocal.m4: libgfortran/configure.ac libgfortran/acinclude.m4
  119. libgfortran/Makefile.in: libgfortran/Makefile.am libgfortran/configure.ac libgfortran/aclocal.m4
  120. libquadmath/configure: libquadmath/configure.ac libquadmath/aclocal.m4
  121. libquadmath/aclocal.m4: libquadmath/configure.ac libquadmath/acinclude.m4
  122. libquadmath/Makefile.in: libquadmath/Makefile.am libquadmath/configure.ac libgfortran/aclocal.m4
  123. libgfortran/configure: libgfortran/configure.ac libgfortran/aclocal.m4
  124. libjava/aclocal.m4: libjava/configure.ac
  125. libjava/Makefile.in: libjava/Makefile.am libjava/configure.ac libjava/aclocal.m4
  126. libjava/configure: libjava/configure.ac libjava/aclocal.m4
  127. libjava/libltdl/aclocal.m4: libjava/libltdl/configure.ac libjava/libltdl/acinclude.m4
  128. libjava/libltdl/Makefile.in: libjava/libltdl/Makefile.am libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
  129. libjava/libltdl/configure: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
  130. libjava/libltdl/config-h.in: libjava/libltdl/configure.ac libjava/libltdl/aclocal.m4
  131. libcpp/aclocal.m4: libcpp/configure.ac
  132. libcpp/Makefile.in: libcpp/configure.ac libcpp/aclocal.m4
  133. libcpp/configure: libcpp/configure.ac libcpp/aclocal.m4
  134. libgomp/aclocal.m4: libgomp/configure.ac libgomp/acinclude.m4
  135. libgomp/Makefile.am: libgomp/plugin/Makefrag.am
  136. libgomp/Makefile.in: libgomp/Makefile.am libgomp/aclocal.m4
  137. libgomp/testsuite/Makefile.in: libgomp/testsuite/Makefile.am libgomp/aclocal.m4
  138. libgomp/configure.ac: libgomp/plugin/configfrag.ac
  139. libgomp/configure: libgomp/configure.ac libgomp/aclocal.m4
  140. libgomp/config.h.in: libgomp/configure.ac libgomp/aclocal.m4
  141. libitm/aclocal.m4: libitm/configure.ac libitm/acinclude.m4
  142. libitm/Makefile.in: libitm/Makefile.am libitm/aclocal.m4
  143. libitm/testsuite/Makefile.in: libitm/testsuite/Makefile.am libitm/aclocal.m4
  144. libitm/configure: libitm/configure.ac libitm/aclocal.m4
  145. libitm/config.h.in: libitm/configure.ac libitm/aclocal.m4
  146. libatomic/aclocal.m4: libatomic/configure.ac libatomic/acinclude.m4
  147. libatomic/Makefile.in: libatomic/Makefile.am libatomic/aclocal.m4
  148. libatomic/testsuite/Makefile.in: libatomic/testsuite/Makefile.am libatomic/aclocal.m4
  149. libatomic/configure: libatomic/configure.ac libatomic/aclocal.m4
  150. libatomic/auto-config.h.in: libatomic/configure.ac libatomic/aclocal.m4
  151. libsanitizer/aclocal.m4: libsanitizer/configure.ac libsanitizer/acinclude.m4
  152. libsanitizer/Makefile.in: libsanitizer/Makefile.am libsanitizer/aclocal.m4
  153. libsanitizer/configure: libsanitizer/configure.ac libsanitizer/aclocal.m4
  154. libsanitizer/asan/Makefile.in: libsanitizer/asan/Makefile.am libsanitizer/aclocal.m4
  155. libsanitizer/interception/Makefile.in: libsanitizer/interception/Makefile.am libsanitizer/aclocal.m4
  156. libsanitizer/sanitizer_common/Makefile.in: libsanitizer/sanitizer_common/Makefile.am libsanitizer/aclocal.m4
  157. libvtv/aclocal.m4: libvtv/configure.ac libvtv/acinclude.m4
  158. libvtv/Makefile.in: libvtv/Makefile.am libvtv/aclocal.m4
  159. libvtv/configure: libvtv/configure.ac libvtv/aclocal.m4
  160. libcilkrts/aclocal.m4: libcilkrts/configure.ac
  161. libcilkrts/Makefile.in: libcilkrts/Makefile.am
  162. libcilkrts/configure: libcilkrts/configure.ac
  163. liboffloadmic/aclocal.m4: liboffloadmic/configure.ac
  164. liboffloadmic/Makefile.in: liboffloadmic/Makefile.am
  165. liboffloadmic/configure: liboffloadmic/configure.ac
  166. liboffloadmic/plugin/aclocal.m4: liboffloadmic/plugin/configure.ac
  167. liboffloadmic/plugin/Makefile.in: liboffloadmic/plugin/Makefile.am
  168. liboffloadmic/plugin/configure: liboffloadmic/plugin/configure.ac
  169. # Top level
  170. Makefile.in: Makefile.tpl Makefile.def
  171. configure: configure.ac config/acx.m4
  172. EOF
  173. }
  174. # This function touches generated files such that the ``end'' user does
  175. # not have to rebuild them.
  176. touch_files () {
  177. rm -f Makefile.$$
  178. echo 'all: \' > Makefile.$$
  179. files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
  180. echo '; @true' >> Makefile.$$
  181. files_and_dependencies | sed 's, ,: ,' >> Makefile.$$
  182. files_and_dependencies | sed 's, .*, \\,' >> Makefile.$$
  183. echo ':' >> Makefile.$$
  184. echo ' @for f in $? $@; do test -f $$f || exit 0; done; \' >> Makefile.$$
  185. echo ' echo Touching $@...; \' >> Makefile.$$
  186. chat ' echo Touching $@... 1>&2; \' >> Makefile.$$
  187. echo ' touch $@' >> Makefile.$$
  188. files_and_dependencies | sed 's,[^ ]* ,,;s,$, :,' >> Makefile.$$
  189. # We would have to explicitly shut off the "Entering... Leaving..."
  190. # messages through "--no-print-directory" to handle the case when
  191. # we were called from a recursive invocation (i.e. "$(MAKE)" in a
  192. # Makefile, not just make). Passing only "-s" doesn't help then,
  193. # because make has helpfully added "-w" to MAKEFLAGS automatically.
  194. # Unfortunately we do not require GNU make other than for building
  195. # and testing, so let's just grep known text explicitly echoed by
  196. # the rule.
  197. while ${MAKE-make} -s -f Makefile.$$ all | grep Touching > /dev/null; do
  198. sleep 1
  199. done 2>&1
  200. rm -f Makefile.$$
  201. }
  202. # Whenever we update the tree or install a patch, we may be modifying
  203. # this script. By re-execing it, we ensure that the appropriate
  204. # dependencies and rules will be used.
  205. touch_files_reexec () {
  206. chat "Adjusting file timestamps"
  207. exec ${CONFIG_SHELL-/bin/sh} $self ${silent+"--silent"} --touch
  208. }
  209. # This functions applies a patch to an existing tree.
  210. apply_patch () {
  211. if [ -f "$1" ]; then
  212. echo "Applying patch file $1"
  213. case $1 in
  214. *gz)
  215. gzip -d -c "$1" | patch -p1 ;;
  216. *bz2)
  217. bzip2 -d -c "$1" | patch -p1 ;;
  218. *)
  219. patch -p1 < "$1";;
  220. esac
  221. fi
  222. touch_files_reexec
  223. }
  224. # Check whether this indeed looks like a local tree.
  225. if [ ! -f gcc/version.c ]; then
  226. echo "This does not seem to be a GCC tree!"
  227. exit
  228. fi
  229. case "$1" in
  230. --silent)
  231. silent=t
  232. shift
  233. ;;
  234. esac
  235. case "$1" in
  236. # First of all, check whether we are going to process a patch.
  237. --patch)
  238. if test "$#" != 2; then
  239. echo "$1" expects only one argument >&2
  240. exit 1
  241. fi
  242. apply_patch "${2}"
  243. exit $?
  244. ;;
  245. --touch)
  246. if test "$#" != 1; then
  247. echo "$1" does not expect any argument >&2
  248. exit 1
  249. fi
  250. touch_files
  251. exit $?
  252. ;;
  253. --list)
  254. if test "$#" != 1; then
  255. echo "$1" does not expect any argument >&2
  256. exit 1
  257. fi
  258. files_and_dependencies | sed 's/ /: /'
  259. exit $?
  260. ;;
  261. --help)
  262. sed -e '1,2d' -e '/^UPDATE_OPTIONS=/{i\
  263. \
  264. p
  265. }' \
  266. -e '/^$/,$d' -e 's/#//' -e 's/^ //' < $0
  267. exit $?
  268. ;;
  269. esac
  270. # Check for known version control systems.
  271. if [ -d .git ]; then
  272. GCC_GIT=${GCC_GIT-${GIT-git}}
  273. vcs_type="git"
  274. elif [ -d .hg ]; then
  275. GCC_HG=${GCC_HG-${HG-hg}}
  276. vcs_type="hg"
  277. elif [ -d .svn ]; then
  278. GCC_SVN=${GCC_SVN-${SVN-svn}}
  279. vcs_type="svn"
  280. else
  281. echo "This does not seem to be a GCC GIT/HG/SVN tree!"
  282. exit
  283. fi
  284. # Check command-line options
  285. if [ x"${1}"x = x"--nostdflags"x ]; then
  286. shift
  287. else
  288. set -- $UPDATE_OPTIONS ${1+"$@"}
  289. fi
  290. case $vcs_type in
  291. git)
  292. chat "Updating GIT tree"
  293. $GCC_GIT diff --quiet --exit-code HEAD
  294. if [ $? -ne 0 ]; then
  295. echo "Attempting to update a dirty git tree!" >&2
  296. echo "Commit or stash your changes first and retry." >&2
  297. exit 1
  298. fi
  299. $GCC_GIT pull ${silent+-q} --rebase ${1+"$@"}
  300. if [ $? -ne 0 ]; then
  301. (touch_files_reexec)
  302. echo "git pull of full tree failed." >&2
  303. exit 1
  304. fi
  305. revision=`$GCC_GIT log -n1 --pretty=%p:%t:%H`
  306. branch=`$GCC_GIT name-rev --name-only HEAD || :`
  307. ;;
  308. hg)
  309. chat "Updating HG tree"
  310. # Add -q so untracked files aren't listed.
  311. if [ `$GCC_HG status -q | wc -l` -gt 0 ]; then
  312. echo "Attempting to update a dirty hg tree!" >&2
  313. echo "Commit or revert your changes first and retry." >&2
  314. exit 1
  315. fi
  316. # Check for mq extension. mq patches must be popped so tip has
  317. # been converted from the SVN tree.
  318. if [ -d .hg/patches ] && [ `$GCC_HG qapplied | wc -l` -gt 0 ]; then
  319. # FIXME: Perhaps pop queue instead? We could do that since we
  320. # know the tree is clean.
  321. echo "Attempting to update hg tree with mq patches applied!" >&2
  322. echo "Pop your patches first and retry." >&2
  323. exit 1
  324. fi
  325. # Update tree, but make sure to only pull the default branch.
  326. # Otherwise all branches in the upstream repo are added, even if
  327. # only a single one has been cloned.
  328. $GCC_HG pull ${silent+-q} -r`$GCC_HG branch` ${1+"$@"}
  329. if [ $? -ne 0 ]; then
  330. (touch_files_reexec)
  331. echo "hg pull of full tree failed." >&2
  332. exit 1
  333. fi
  334. # Update tree. Needs to be done separately from pull so
  335. # gcc_update -rREV works.
  336. $GCC_HG update ${silent+-q} ${1+"$@"}
  337. if [ $? -ne 0 ]; then
  338. (touch_files_reexec)
  339. echo "hg update of full tree failed." >&2
  340. exit 1
  341. fi
  342. # Extract SVN revision corresponding to parents, as stored by
  343. # hg convert. Before hg 1.4.3, there's no template keyword
  344. # corresponding to the extra: tag, so need to use hg log --debug
  345. # to extract the info.
  346. parents=`$GCC_HG parents --template '{rev}'`
  347. convert_revision=`$GCC_HG log --debug -r$parents | \
  348. sed -ne "/^extra:.*convert_revision=svn:/ {
  349. s%^[^/]*/%%
  350. p
  351. }"`
  352. revision=`echo $convert_revision | sed -e 's/.*@//'`
  353. branch=`echo $convert_revision | sed -e 's%branches/%%' -e 's/@.*//'`
  354. ;;
  355. svn)
  356. chat "Updating SVN tree"
  357. $GCC_SVN ${silent+-q} --non-interactive update ${1+"$@"}
  358. if [ $? -ne 0 ]; then
  359. (touch_files_reexec)
  360. echo "SVN update of full tree failed." >&2
  361. exit 1
  362. fi
  363. revision=`$GCC_SVN info | awk '/Revision:/ { print $2 }'`
  364. branch=`$GCC_SVN info | sed -ne "/^URL:/ {
  365. s,.*/trunk,trunk,
  366. s,.*/branches/,,
  367. s,.*/tags/,,
  368. p
  369. }"`
  370. ;;
  371. esac
  372. rm -f LAST_UPDATED gcc/REVISION
  373. {
  374. date
  375. echo "`TZ=UTC date` (revision $revision)"
  376. } > LAST_UPDATED
  377. echo "[$branch revision $revision]" > gcc/REVISION
  378. touch_files_reexec